Index: sys/ufs/ufs/ufs_extattr.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_extattr.c,v
retrieving revision 1.15
diff -u -r1.15 ufs_extattr.c
--- sys/ufs/ufs/ufs_extattr.c	2000/10/09 20:04:39	1.15
+++ sys/ufs/ufs/ufs_extattr.c	2000/10/11 17:49:26
@@ -367,8 +367,9 @@
 	 * Processes with privilege, but in jail, are not allowed to
 	 * configure extended attributes.
 	 */
-	if ((error = suser_xxx(p->p_cred->pc_ucred, p, 0)))
+	if ((error = cap_check(p->p_cred->pc_ucred, p, CAP_SYS_ADMIN, 0)))
 		return (error);
+	suser_used(p);
 
 	switch(cmd) {
 	case UFS_EXTATTR_CMD_START:
@@ -424,13 +425,16 @@
 ufs_extattr_credcheck(struct vnode *vp, struct ufs_extattr_list_entry *uele,
     struct ucred *cred, struct proc *p, int access)
 {
-	int	system_namespace;
+	int	system_namespace, error;
 
 	system_namespace = (strlen(uele->uele_attrname) >= 1 &&
 	    uele->uele_attrname[0] == '$');
 
 	/*
-	 * Kernel-invoked always succeeds
+	 * Kernel-invoked always succeeds.
+	 *
+	 * XXX: Is this correct?  Might be appropriate to check also
+	 * whether the inode is immutable, et al.
 	 */
 	if (cred == NULL)
 		return (0);
@@ -442,9 +446,12 @@
 	 * XXX What capability should apply here?
 	 * Probably CAP_SYS_SETFFLAG.
 	 */
-	if (system_namespace)
-		return (suser_xxx(cred, p, 0));
-	else
+	if (system_namespace) {
+		if ((error = cap_check(cred, p, CAP_SYS_ADMIN, 0)))
+			return (error);
+		suser_used(p);
+		return (0);
+	} else
 		return (VOP_ACCESS(vp, access, cred, p));
 }
 
Index: sys/ufs/ufs/ufs_readwrite.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_readwrite.c,v
retrieving revision 1.73
diff -u -r1.73 ufs_readwrite.c
--- sys/ufs/ufs/ufs_readwrite.c	2000/12/26 19:41:37	1.73
+++ sys/ufs/ufs/ufs_readwrite.c	2001/01/05 17:42:45
@@ -530,7 +530,7 @@
 	 * tampering.
 	 */
 	if (resid > uio->uio_resid && ap->a_cred && 
-	    suser_xxx(ap->a_cred, NULL, PRISON_ROOT))
+	    cap_check(ap->a_cred, NULL, CAP_FSETID, PRISON_ROOT))
 		ip->i_mode &= ~(ISUID | ISGID);
 	if (resid > uio->uio_resid)
 		VN_KNOTE(vp, NOTE_WRITE | (extended ? NOTE_EXTEND : 0));
Index: sys/ufs/ufs/ufs_vfsops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_vfsops.c,v
retrieving revision 1.20
diff -u -r1.20 ufs_vfsops.c
--- sys/ufs/ufs/ufs_vfsops.c	2000/10/30 20:37:19	1.20
+++ sys/ufs/ufs/ufs_vfsops.c	2000/11/07 02:47:26
@@ -103,7 +103,7 @@
 #ifndef QUOTA
 	return (EOPNOTSUPP);
 #else
-	int cmd, type, error;
+	int cmd, type, error, privilege_used = 0;
 
 	if (uid == -1)
 		uid = p->p_cred->p_ruid;
@@ -117,8 +117,9 @@
 			break;
 		/* fall through */
 	default:
-		if ((error = suser_xxx(0, p, PRISON_ROOT)) != 0)
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, PRISON_ROOT)))
 			return (error);
+		privilege_used = 1;
 	}
 
 	type = cmds & SUBCMDMASK;
@@ -158,6 +159,8 @@
 		break;
 	}
 	vfs_unbusy(mp, p);
+	if (error == 0 && privilege_used)
+		suser_used(p);
 	return (error);
 #endif
 }
Index: sys/ufs/ufs/ufs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_vnops.c,v
retrieving revision 1.154
diff -u -r1.154 ufs_vnops.c
--- sys/ufs/ufs/ufs_vnops.c	2000/11/04 08:10:56	1.154
+++ sys/ufs/ufs/ufs_vnops.c	2001/01/07 17:22:45
@@ -58,6 +58,7 @@
 #include <sys/lockf.h>
 #include <sys/event.h>
 #include <sys/conf.h>
+#include <sys/capability.h>
 
 #include <machine/mutex.h>
 
@@ -303,9 +304,7 @@
 	struct vnode *vp = ap->a_vp;
 	struct inode *ip = VTOI(vp);
 	mode_t mode = ap->a_mode;
-#ifdef QUOTA
-	int error;
-#endif
+	int error, privused;
 
 	/*
 	 * Disallow write attempts on read-only file systems;
@@ -332,9 +331,16 @@
 	/* If immutable bit set, nobody gets to write it. */
 	if ((mode & VWRITE) && (ip->i_flags & (IMMUTABLE | SF_SNAPSHOT)))
 		return (EPERM);
+
+	privused = 0;
+	error = vaccess(vp->v_type, ip->i_mode, ip->i_uid, ip->i_gid,
+	    ap->a_mode, ap->a_cred, &privused);
+	if (error)
+		return (error);
+	if (privused)
+		suser_used(ap->a_p);
 
-	return (vaccess(vp->v_type, ip->i_mode, ip->i_uid, ip->i_gid,
-	    ap->a_mode, ap->a_cred, NULL));
+	return (0);
 }
 
 /* ARGSUSED */
@@ -396,7 +402,7 @@
 	struct inode *ip = VTOI(vp);
 	struct ucred *cred = ap->a_cred;
 	struct proc *p = ap->a_p;
-	int error;
+	int error, privilege_used = 0;
 
 	/*
 	 * Check for unsettable attributes.
@@ -413,16 +419,21 @@
 		/*
 		 * Callers may only modify the file flags on objects they
 		 * have VADMIN rights for.
+		 *
+		 * XXX: This abstracts use of privilege, and may not
+		 * account for it properly.
 		 */
 		if ((error = VOP_ACCESS(vp, VADMIN, cred, p)))
 			return (error);
+
 		/*
 		 * Unprivileged processes and privileged processes in
 		 * jail() are not permitted to set system flags.
 		 * Privileged processes not in jail() may only set system
 		 * flags if the securelevel <= 0.
 		 */
-		if (!suser_xxx(cred, NULL, 0)) {
+		if (!cap_check(cred, p, CAP_SYS_SETFFLAG, 0)) {
+			privilege_used = 1;
 			if ((ip->i_flags
 			    & (SF_NOUNLINK | SF_IMMUTABLE | SF_APPEND)) &&
 			    securelevel > 0)
@@ -443,8 +454,11 @@
 			ip->i_flags |= (vap->va_flags & UF_SETTABLE);
 		}
 		ip->i_flag |= IN_CHANGE;
-		if (vap->va_flags & (IMMUTABLE | APPEND))
+		if (vap->va_flags & (IMMUTABLE | APPEND)) {
+			if (privilege_used)
+				suser_used(p);
 			return (0);
+		}
 	}
 	if (ip->i_flags & (IMMUTABLE | APPEND))
 		return (EPERM);
@@ -495,8 +509,12 @@
 		 */
 		if ((error = VOP_ACCESS(vp, VADMIN, cred, p)) &&
 		    ((vap->va_vaflags & VA_UTIMES_NULL) == 0 ||
-		    (error = VOP_ACCESS(vp, VWRITE, cred, p))))
-			return (error);
+		    (error = VOP_ACCESS(vp, VWRITE, cred, p)))) {
+			if ((error = cap_check(cred, p, CAP_FOWNER,
+			    PRISON_ROOT)) != 0)
+				return (error);
+			privilege_used = 1;
+		}
 		if (vap->va_atime.tv_sec != VNOVAL)
 			ip->i_flag |= IN_ACCESS;
 		if (vap->va_mtime.tv_sec != VNOVAL)
@@ -524,6 +542,8 @@
 		error = ufs_chmod(vp, (int)vap->va_mode, cred, p);
 	}
 	VN_KNOTE(vp, NOTE_ATTRIB);
+	if (error == 0 && privilege_used)
+		suser_used(p);
 	return (error);
 }
 
@@ -539,28 +559,55 @@
 	struct proc *p;
 {
 	register struct inode *ip = VTOI(vp);
-	int error;
+	int error, privilege_used = 0;
 
 	/*
-	 * To modify the permissions on a file, must possess VADMIN
-	 * for that file.
+	 * In general, to modify the permissions on a file, you must posess
+	 * VADMIN for the file (by virtue of owning the file, or having
+	 * privilege such as super-user or CAP_FOWNER).  However, if the
+	 * modification involves either of the setugid bits being in the
+	 * new mode, additional checks are performed: for setuid, the
+	 * effective uid of the process must match the inode uid or
+	 * superuser/CAP_FSETID must be held, and for setgid, one of the
+	 * groups of the process must match that of the file, or supuser/
+	 * CAP_FSETID must be held.
+	 *
+	 * XXX: This diverges slightly from POSIX.1e D17 by tightening the
+	 * requirements: both CAP_FOWNER and CAP_FSETID must be held to
+	 * update sugid bits, but this divergence is portable to at least
+	 * Linux, and substantially simplifies (and makes sensical) the
+	 * interactions.
 	 */
 	if ((error = VOP_ACCESS(vp, VADMIN, cred, p)))
 		return (error);
 	/*
-	 * Privileged processes may set the sticky bit on non-directories,
-	 * as well as set the setgid bit on a file with a group that the
-	 * process is not a member of.
-	 */
-	if (suser_xxx(cred, NULL, PRISON_ROOT)) {
-		if (vp->v_type != VDIR && (mode & S_ISTXT))
-			return (EFTYPE);
-		if (!groupmember(ip->i_gid, cred) && (mode & ISGID))
-			return (EPERM);
+	 * Traditionally, privilege has allowed a process to set the
+	 * sticky bit on non-directories.  However, this has no meaning,
+	 * so is now disabled.
+	 */
+	if (vp->v_type != VDIR && (mode & S_ISTXT))
+		return(EFTYPE);
+	/*
+	 * Privilege is required to set the setuid or setgid bits if the
+	 * process doesn't already have access to the respective uid
+	 * or gid in its credentials.
+	 * XXX: Check that uid/gid checks here fit abstractions.
+	 */
+	if ((ip->i_uid != cred->cr_uid) && (mode & ISUID)) {
+		if ((error = cap_check(cred, p, CAP_FSETID, PRISON_ROOT)) != 0)
+			return (error);
+		privilege_used = 1;
+	}
+	if (!groupmember(ip->i_gid, cred) && (mode & ISGID)) {
+		if ((error = cap_check(cred, p, CAP_FSETID, PRISON_ROOT)) != 0)
+			return (error);
+		privilege_used = 1;
 	}
 	ip->i_mode &= ~ALLPERMS;
 	ip->i_mode |= (mode & ALLPERMS);
 	ip->i_flag |= IN_CHANGE;
+	if (privilege_used)
+		suser_used(p);
 	return (0);
 }
 
@@ -579,7 +626,7 @@
 	register struct inode *ip = VTOI(vp);
 	uid_t ouid;
 	gid_t ogid;
-	int error = 0;
+	int error = 0, privilege_used = 0;
 #ifdef QUOTA
 	register int i;
 	long change;
@@ -600,10 +647,12 @@
 	 * to a group of which we are not a member, the caller must
 	 * have privilege.
 	 */
-	if ((uid != ip->i_uid || 
-	    (gid != ip->i_gid && !groupmember(gid, cred))) &&
-	    (error = suser_xxx(cred, p, PRISON_ROOT)))
-		return (error);
+	if (uid != ip->i_uid || 
+	    (gid != ip->i_gid && !groupmember(gid, cred))) {
+	    	if (error = cap_check(cred, p, CAP_CHOWN, PRISON_ROOT)))
+			return (error);
+		privilege_used = 1;
+	}
 	ogid = ip->i_gid;
 	ouid = ip->i_uid;
 #ifdef QUOTA
@@ -669,8 +718,14 @@
 		panic("ufs_chown: lost quota");
 #endif /* QUOTA */
 	ip->i_flag |= IN_CHANGE;
-	if (suser_xxx(cred, NULL, PRISON_ROOT) && (ouid != uid || ogid != gid))
-		ip->i_mode &= ~(ISUID | ISGID);
+	if (ouid != uid || ogid != gid) {
+		if (cap_check(cred, p, CAP_FSETID, PRISON_ROOT) != 0)
+			ip->i_mode &= ~(ISUID | ISGID);
+		else
+			privilege_used = 1;
+	}
+	if (privilege_used)
+		suser_used(p);
 	return (0);
 }
 
@@ -866,7 +921,7 @@
 	struct inode *ip, *xp, *dp;
 	struct direct newdir;
 	int doingdirectory = 0, oldparent = 0, newparent = 0;
-	int error = 0, ioflag;
+	int error = 0, ioflag, privilege_used = 0;
 
 #ifdef DIAGNOSTIC
 	if ((tcnp->cn_flags & HASBUF) == 0 ||
@@ -1104,6 +1159,14 @@
 		 * must possess VADMIN for the parent directory, or the
 		 * destination of the rename.  This implements append-only
 		 * directories.
+		 *
+		 * XXX: In TRIX, CAP_DAC_WRITE appears also to override the
+		 * sticky bit limitations -- should we do the same?  Such a
+		 * check would read:
+		 *	(cap_check(tcnp->cn_cred, NULL, CAP_DAC_WRITE,
+		 *	    PRISON_ROOT))
+		 * XXX: Since the introduction of VADMIN, the ability to
+		 * set privilege_used here has been lost.
 		 */
 		if ((dp->i_mode & S_ISTXT) &&
 		    VOP_ACCESS(tdvp, VADMIN, tcnp->cn_cred, p) &&
@@ -1197,6 +1260,8 @@
 		if (doingdirectory)
 			panic("ufs_rename: lost dir entry");
 		vrele(ap->a_fvp);
+		if (privilege_used)
+			suser_used(p);
 		return (0);
 	}
 	/*
@@ -1232,6 +1297,8 @@
 	if (xp)
 		vput(fvp);
 	vrele(ap->a_fvp);
+	if (error == 0 && privilege_used)
+		suser_used(p);
 	return (error);
 
 bad:
@@ -1251,6 +1318,8 @@
 		vput(fvp);
 	} else
 		vrele(fvp);
+	if (error == 0 && privilege_used)
+		suser_used(p);
 	return (error);
 }
 
@@ -2055,7 +2124,7 @@
 	register struct inode *ip, *pdir;
 	struct direct newdir;
 	struct vnode *tvp;
-	int error;
+	int error, privilege_used = 0;
 
 	pdir = VTOI(dvp);
 #ifdef DIAGNOSTIC
@@ -2133,9 +2202,12 @@
 	ip->i_nlink = 1;
 	if (DOINGSOFTDEP(tvp))
 		softdep_change_linkcnt(ip);
-	if ((ip->i_mode & ISGID) && !groupmember(ip->i_gid, cnp->cn_cred) &&
-	    suser_xxx(cnp->cn_cred, NULL, PRISON_ROOT))
-		ip->i_mode &= ~ISGID;
+	if ((ip->i_mode & ISGID) && !groupmember(ip->i_gid, cnp->cn_cred)) {
+		if (cap_check(cnp->cn_cred, NULL, CAP_FSETID, PRISON_ROOT))
+			ip->i_mode &= ~ISGID;
+		else
+			privilege_used = 1;
+	}
 
 	if (cnp->cn_flags & ISWHITEOUT)
 		ip->i_flags |= UF_OPAQUE;
@@ -2151,6 +2223,13 @@
 	if (error)
 		goto bad;
 	*vpp = tvp;
+/*
+	XXX struct proc is not passed in, so we can't mark as having used
+	    privilege
+
+	if (privilege_used)
+		suser_used(p);
+*/
 	return (0);
 
 bad:
Index: sys/vm/vm_mmap.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_mmap.c,v
retrieving revision 1.117
diff -u -r1.117 vm_mmap.c
--- sys/vm/vm_mmap.c	2000/11/18 21:01:04	1.117
+++ sys/vm/vm_mmap.c	2000/12/13 05:40:58
@@ -335,8 +335,11 @@
 			 */
 			if (securelevel >= 1)
 				disablexworkaround = 1;
-			else
-				disablexworkaround = suser(p);
+			else {
+				/* XXX How to suser_used() here? */
+				disablexworkaround = cap_check(NULL, p,
+				   CAP_SYS_RAWIO, 0);
+			}
 			if (vp->v_type == VCHR && disablexworkaround &&
 			    (flags & (MAP_PRIVATE|MAP_COPY))) {
 				error = EINVAL;
Index: sys/vm/vm_swap.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_swap.c,v
retrieving revision 1.106
diff -u -r1.106 vm_swap.c
--- sys/vm/vm_swap.c	2000/12/13 10:01:00	1.106
+++ sys/vm/vm_swap.c	2001/01/05 17:42:49
@@ -191,9 +191,10 @@
 	struct nameidata nd;
 	int error;
 
-	error = suser(p);
+	error = cap_check(NULL, p, CAP_SYS_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(p);
 
 	/*
 	 * Swap metadata may not fit in the KVM if we have physical
Index: usr.bin/find/function.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/find/function.c,v
retrieving revision 1.27
diff -u -r1.27 function.c
--- usr.bin/find/function.c	2000/07/28 20:02:42	1.27
+++ usr.bin/find/function.c	2000/08/07 00:56:16
@@ -44,6 +44,7 @@
 #endif /* not lint */
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/stat.h>
 #include <sys/wait.h>
Index: usr.bin/kdump/Makefile
===================================================================
RCS file: /home/ncvs/src/usr.bin/kdump/Makefile,v
retrieving revision 1.7
diff -u -r1.7 Makefile
--- usr.bin/kdump/Makefile	2000/09/14 18:52:48	1.7
+++ usr.bin/kdump/Makefile	2000/09/16 03:39:24
@@ -2,7 +2,7 @@
 # $FreeBSD: src/usr.bin/kdump/Makefile,v 1.7 2000/09/14 18:52:48 jkh Exp $
 
 PROG=	kdump
-CFLAGS+=-I${.CURDIR}/../ktrace -I${.CURDIR}/../..
+CFLAGS+=-I${.CURDIR}/../ktrace -I${.CURDIR}/../.. -I${.CURDIR}/../../sys
 SRCS=	kdump.c ioctl.c subr.c
 .PATH:	${.CURDIR}/../ktrace
 CLEANFILES+=ioctl.c
Index: usr.sbin/inetd/builtins.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/inetd/builtins.c,v
retrieving revision 1.29
diff -u -r1.29 builtins.c
--- usr.sbin/inetd/builtins.c	2000/12/05 13:56:01	1.29
+++ usr.sbin/inetd/builtins.c	2000/12/13 05:43:44
@@ -33,6 +33,7 @@
 #include <sys/stat.h>
 #include <sys/socket.h>
 #include <sys/sysctl.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/uio.h>
 #include <sys/utsname.h>
Index: usr.sbin/pstat/pstat.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/pstat/pstat.c,v
retrieving revision 1.52
diff -u -r1.52 pstat.c
--- usr.sbin/pstat/pstat.c	2000/12/30 15:41:40	1.52
+++ usr.sbin/pstat/pstat.c	2001/01/05 17:49:03
@@ -48,6 +48,7 @@
 #include <sys/param.h>
 #include <sys/time.h>
 #include <sys/vnode.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #define _KERNEL
 #include <sys/file.h>
Index: usr.sbin/rpc.umntall/rpc.umntall.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/rpc.umntall/rpc.umntall.c,v
retrieving revision 1.3
diff -u -r1.3 rpc.umntall.c
--- usr.sbin/rpc.umntall/rpc.umntall.c	2000/01/15 14:28:14	1.3
+++ usr.sbin/rpc.umntall/rpc.umntall.c	2000/04/12 20:10:46
@@ -31,6 +31,7 @@
 #endif /* not lint */
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/mount.h>
 
